Index: channels/chan_iax2.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_iax2.c,v
retrieving revision 1.257
diff -u -u -r1.257 chan_iax2.c
--- channels/chan_iax2.c	18 Mar 2005 00:32:49 -0000	1.257
+++ channels/chan_iax2.c	22 Mar 2005 21:11:41 -0000
@@ -2566,8 +2566,12 @@
 				peerl.peers = peer;
 				ast_mutex_unlock(&peerl.lock);
 				ast_copy_flags(peer, &globalflags, IAX_RTAUTOCLEAR|IAX_RTCACHEFRIENDS);
-				if (ast_test_flag(peer, IAX_RTAUTOCLEAR))
+				if (ast_test_flag(peer, IAX_RTAUTOCLEAR)) {
+					if (peer->expire > -1) {
+						ast_sched_del(sched, peer->expire);
+					}
 					peer->expire = ast_sched_add(sched, (global_rtautoclear) * 1000, expire_registry, (void *)peer);
+				}
 			} else {
 		    		ast_set_flag(peer, IAX_TEMPONLY);	
 			}
